// -*- C++ -*-

#ifndef _H_MADMETRIC
#define _H_MADMETRIC


#ifdef _HAVE_GMSH_

#include "gmsh/STensor3.h"
namespace MAd {
  typedef SMetric3 metric;
}

#else

#include "MAdMessage.h"
#include "MAdMatrix.h"
#include "MAdVector3.h"

namespace MAd {

  class MAdMetric
  {
  public:

    MAdMetric(const double v = 1.0) {
      MAdMsgSgl::instance().error(__LINE__,__FILE__,
                                  "Metric not implemented in MAdLib, Gmsh required");
    }
    MAdMetric(const double, const double, const double,
              const vec3 &, const vec3 &, const vec3 &) {
      MAdMsgSgl::instance().error(__LINE__,__FILE__,
                                  "Metric not implemented in MAdLib, Gmsh required");
    }

    inline int getIndex(int i, int j) const{return -1;}
    inline double &operator()(int i, int j) {}
    inline double operator() (int i, int j) const {return -1.;}  
    MAdMetric invert () const { return MAdMetric(); }
    MAdMetric operator + (const MAdMetric &other) const { return MAdMetric(); }
    MAdMetric& operator += (const MAdMetric &other)  { return *this; }
    MAdMetric& operator *= (const double &other) { return *this; }
    MAdMetric& operator *= (const MAdMetric &other) { return *this; }
    void eig (gmshMat &V, gmshVec &S) const {  }
    void print(std::string name="") const {}
  };

  typedef MAdMetric metric;

  inline double dot(const vec3 &a, const metric &m, const vec3 &b) { return -1.; }

}

#endif

#endif
